/* ==================================== pwg.print.job.description.N.h ===================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PRINT_JOB_DESCRIPTION__N_H__
#define __PWG_PRINT_JOB_DESCRIPTION__N_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.print.job.ticket.config.h"

#include "pwg.elements[.document].natural.language.h"
#include "pwg.job.accounting.id.h"
#include "pwg.job.accounting.user.id.h"
#include "pwg.job.more.info.h"
#include "pwg.job.originating.user.name.h"
#include "pwg.document.charset.supplied.h"
#include "pwg.document.format[.supplied].h"
#include "pwg.document.format.version[.supplied].h"
#include "pwg.document.name[.supplied].h"
#include "pwg.document.uri.h"
#include "pwg.job.collation.type.h"
#include "pwg.page.order.received.h"

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
#include "pwg.document.format.details.supplied.h"
#include "pwg.job.name.h"
#include "pwg.job.originating.user.uri.h"
#include "pwg.job.pages.h"
#include "pwg.k.octets.h"
#include "pwg.impressions.h"
#include "pwg.media.sheets.h"
#endif

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
#include "pwg.job.message.from.operator.h"
#include "pwg.job.message.to.operator.h"

#include "pwg.job.password.h"
#include "pwg.job.password.encryption.h"

#include "pwg.template.creator.user.name.h"
#include "pwg.template.id.h"
#include "pwg.template.info.h"
#include "pwg.template.name.h"
#include "pwg.template.type.h"
#include "pwg.compression[.supplied].h"
#include "pwg.document.digital.signature[.supplied].h"
#include "pwg.document.message[.supplied].h"
#include "pwg.document.meta.data.h"
#endif

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Print Job Description                                                                                    */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.2 [page 23-25] PrintJobDescription                                                               */
/* -----------------                                                                                        */
/*  [From Overview Section 4.1] PrintJobDescription  and PrintJobProcessing elements  apply  to  the        */
/*                              entire  Job.                                                                */
/*                                                                                                          */
/* Figure 13 and Figure 14 show the elements that make up the PrintJobDescription group of elements. The    */
/* subsections below show the complex PrintJobProcessing elements' datatypes.                               */
/*                                                                                                          */
/*                              + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +       */
/*                              .  PrintJobDescriptionType                                          .       */
/*                              .                                                                   .       */
/*                              .     +------------+                                                .       */
/*                              . +---| attributes |                                                .       */
/*                              . |   +------------+                                                .       */
/*                              . |                                                                 .       */
/*                              . |                  + - - - - - - - - - - - - + 123                .       */
/*                              . |              + - ! ElementsNaturalLanguage !                    .       */
/*                              . |              !   K - - - - - - - - - - - - +                    .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - + 123                        .       */
/*                              . |              + - ! JobAccountingID !                            .       */
/*                              . |              !   S - - - - - - - - +                            .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - + 123                    .       */
/*                              . |              + - ! JobAccountingUserID !                        .       */
/*                              . |              !   S - - - - - - - - - - +                        .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + 123                            .       */
/*                              . |              + - ! JobMoreInfo !                                .       */
/*                              . |              !   U - - - - - - +                                .       */
/*                              . |              !                                                  .       */
/*                              . | /---------\  !   +---------+ 123                                .       */
/*                              . +-| -o-o-o- |--+---| JobName |                                    .       */
/*                              . | \---------/  !   S---------+ Required                           .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - + 123                .       */
/*                              . |              + - ! JobOriginatingUserName  !                    .       */
/*                              . |              !   S - - - - - - - - - - - - + Required           .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - + 123                .       */
/*                              . |              + - ! DocumentCharsetSupplied !                    .       */
/*                              . |              !   K - - - - - - - - - - - - + Required           .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - + 123                .       */
/*                              . |              + - ! DocumentFormatSupplied  !                    .       */
/*                              . |              !   K - - - - - - - - - - - - +                    .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - - - - + 123          .       */
/*                              . |              + - ! DocumentFormatVersionSupplied !              .       */
/*                              . |              !   S - - - - - - - - - - - - - - - +              .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - + 123                  .       */
/*                              . |              + - ! DocumentNameSupplied  !                      .       */
/*                              . |              !   S - - - - - - - - - - - +                      .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + 123                            .       */
/*                              . |              + - ! DocumentUri !                                .       */
/*                              . |              !   U - - - - - - + Required                       .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! JobCollationType  !                          .       */
/*                              . |              !   K - - - - - - - - - +                          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! PageOrderReceived !                          .       */
/*                              . |              !   K - - - - - - - - - +                          .       */
/*                              . |              !                                                  .       */
/* 2222222222222222222222222222222|222222222222222222222222222222222222222222222222222222222222222222222222 */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - - - - + .23          .       */
/*                              . |              + - ! DocumentFormatDetailsSupplied !+             .       */
/*                              . |              !   C - - - - - - - - - - - - - - - +              .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - + .23                  .       */
/*                              . |              + - ! JobOriginatingUserUri !                      .       */
/*                              . |              !   U - - - - - - - - - - - +  Conditionally       .       */
/*                              . |              !                                Required          .       */
/*                              . |              !   + - - - - - + .23                              .       */
/*                              . |              + - ! JobPages  !                                  .       */
/*                              . |              !   I - - - - - +                                  .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - + .23                                .       */
/*                              . |              + - ! KOctets !                                    .       */
/*                              . |              !   I - - - - +                                    .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + .23                            .       */
/*                              . |              + - ! Impressions !                                .       */
/*                              . |              !   I - - - - - - +                                .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + .23                            .       */
/*                              . |              + - ! MediaSheets !                                .       */
/*                              . |              !   I - - - - - - +                                .       */
/*                              . |              !                                                  .       */
/* 3333333333333333333333333333333|333333333333333333333333333333333333333333333333333333333333333333333333 */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - + ..3                .       */
/*                              . |              + - ! JobMessageFromOperator  !                    .       */
/*                              . |              !   S - - - - - - - - - - - - +                    .       */
/*                              . |              !                                                  .       */
/*     +---------------------+  . |              !   + - - - - - - - - - - - + ..3                  .       */
/*     | PrintJobDescription |--.-+              + - ! JobMessageToOperator  !                      .       */
/*     +---------------------+  . |              !   S - - - - - - - - - - - +                      .       */
/*                              . |              !                                                  .       */
/*                              . |              !                    + - - - - - - - - - - - - + ..3       */
/*                              . |              !                + - ! TemplateCreatorUserName !   .       */
/*                              . |              !                !   S - - - - - - - - - - - - +   .       */
/*                              . |              !                !                                 .       */
/*                              . |              !                !   + - - - - - - + ..3           .       */
/*                              . |              !                + - ! TemplateId  !               .       */
/*                              . |              !                !   U - - - - - - +               .       */
/*                              . |              !                !                                 .       */
/*                              . |              !   /- - - - -\  !   + - - - - - - - + ..3         .       */
/*                              . |              + - ! -o-o-o- !- + - ! TemplateInfo  !             .       */
/*                              . |                  \- - - - -/  !   S - - - - - - - +             .       */
/*                              . |                               !                                 .       */
/*                              . |                               !   + - - - - - - - + ..3         .       */
/*                              . |                               + - ! TemplateName  !             .       */
/*                              . |                               !   S - - - - - - - +             .       */
/*                              . |                               !                                 .       */
/*                              . |                               !   + - - - - - - - + ..3         .       */
/*                              . |                               + - ! TemplateType  !             .       */
/*                              . |                                   K - - - - - - - +             .       */
/*                              . |                                                                 .       */
/*                              . |                  + - - - - - - - - - - - + ..3                  .       */
/*                              . |              + - ! CompresssionSupplied  !                      .       */
/*                              . |              !   K - - - - - - - - - - - + Conditionally        .       */
/*                              . |              !                               Required           .       */
/*                              . |              !   + - - - - - - - - - - - - - - - - - + ..3      .       */
/*                              . |              + - ! DocumentDigitalSignatureSupplied  !          .       */
/*                              . |              !   K - - - - - - - - - - - - - - - - - +          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - - + ..3                .       */
/*                              . |              + - ! DocumentMessageSupplied !                    .       */
/*                              . |              !   S - - - - - - - - - - - - +                    .       */
/*                              . |              !                                                  .       */
/*                              . | /---------\  !   + - - - - - - - - - + ..3                      .       */
/*                              . +-| -o-o-o- |- + - ! DocumentMetaData  !+                         .       */
/*                              .   \---------/  !   C - - - - - - - - - +                          .       */
/*                              .                !                                                  .       */
/* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
/*                              .                !                                                  .       */
/*                              .                !   / - - - - - - -\ 123                           .       */
/*                              .                + - ! any ##other  !                               .       */
/*                              .                    \ - - - - - - -/                               .       */
/*                              .                        0..infinite                                .       */
/*                              + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +       */
/*                                                                                                          */
/*                                      Figure 13 PrintJobDescription (1)                                   */
/*                                      Figure 14 PrintJobDescription (2)                                   */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + - - - - + 123                      ! = Optional    */
/*      ! Optional Element  !   | Required Element |   | Element | ^^^ Support Level        | = Required    */
/*      X - - - - - - - - - Y   X------------------Y   + - - - - +                                          */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
typedef struct {
   pwgElementsNaturalLanguageEnum  elementsNaturalLanguage; /* Natural language for text elements           */
                          pwgCHAR  jobAccountingId[pwgMAX_JOB_ACC_ID]; /* Account associated with the job.  */
                          pwgCHAR  jobAccountingUserId[pwgMAX_JOB_ACC_USER_ID]; /* User account for job     */
                          pwgCHAR  jobMoreInfoUri[pwgMAX_URI_SIZE]; /* URI ref to more info about the job   */
                          pwgCHAR  jobName[pwgMAX_JOB_NAME_SIZE]; /* User friendly name of the Job.         */
                          pwgCHAR  jobOriginatingUserName[pwgMAX_JOB_ORIG_USER_NAME_SIZE];
   pwgDocumentCharsetSuppliedEnum  docCharsetSupplied;      /* Default charset of the Documents content.    */
            pwgDocumentFormatEnum  docFormatSupplied;       /* Document format for the Document content.    */
                          pwgCHAR  docFormatVersionSuppliled[pwgMAX_DOC_FMT_VER_SIZE];/* Doc Format Version */
                          pwgCHAR  docNameSupplied[pwgMAX_DOC_NAME_SIZE]; /* Supplied Document Name         */
                          pwgCHAR  docUri[pwgMAX_URI_SIZE]; /* URI reference to the document of this job    */
          pwgJobCollationTypeEnum  jobCollType;             /* Sheet/document collation for the Job         */
         pwgPageOrderReceivedEnum  pageOrderReceived;       /* Page order Document data is supplied         */


#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
 pwgDocumentFormatDetailsSupplied  docFormatDetailsSupplied;/* Summarizes distinctions contained doc fmts.  */
                          pwgCHAR  jobOriginatingUserUri[pwgMAX_URI_SIZE]; /* URI ref to end user           */
                         pwgBIT32  jobPages;                /* Total number input pages of documents in Job */
                         pwgBIT32  kOctets;                 /* Total size of Job Doc's in 1024 octets.      */
                         pwgBIT32  impressions;             /* Number of impressions for all Document(s).   */
                         pwgBIT32  mediaSheets;             /* Number media sheets produced for this Doc    */
#endif

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
                          pwgCHAR  jobMessageFromOperator[pwgMAX_JOB_MESS_FROM_OPR];/* Message from operator*/
                          pwgCHAR  jobMessageToOperator[pwgMAX_JOB_MESS_TO_OPR];/* User Message to operator */

                          pwgBIT8  jobPassword[pwgMAX_PASSWORD_SIZE]; /* Password supplied by the client    */
     pwgJobPasswordEncryptionEnum  jobPasswordEncryption;   /* Encryption for the supplied Job Password     */

                          pwgCHAR  templateCreatorUserName[pwgMAX_TEMPLATE_CREATOR_USER_NAME];
                          pwgCHAR  templateId[pwgMAX_URI_SIZE]; /* URI to template Id                       */
                          pwgCHAR  templateInfo[pwgMAX_TEMPLATE_INFO_SIZE];/* Info for template             */
                          pwgCHAR  templateName[pwgMAX_TEMPLATE_NAME_SIZE];/* Name for template             */
              pwgTemplateTypeEnum  templateType;            /* Template Type used to create the Job Ticket  */
       pwgCompressionSuppliedEnum  compressionSupplied;     /* compression algorithm for all Job Document's */
pwgDocumentDigitalSignatureSuppliedEnum  docDigitalSignatureSupplied;/*Digital signature type for Doc Conten*/
                          pwgCHAR  docMessageSupplied[pwgMAX_DOC_MESSAGE_SIZE];/* Message (to operator)     */
                          pwgCHAR  docMetadata[pwgMAX_DOC_META_DATA_SIZE];/* Document Meta Data             */
#endif

                          VND_PRT_JOB_DESC_STRUCT

} pwgPrintJobDescription;

typedef struct {
    pwgNUM_RNG_DEF* naturalLangDef;                   /* Natural language for text elements                 */
       pwgINFO_DEF* jobAccountingId;                  /* Account associated with the job.                   */
       pwgINFO_DEF* jobAccountingUserId;              /* User account for job                               */
       pwgINFO_DEF* jobMoreInfoUri;                   /* URI ref to more info about the job                 */
       pwgINFO_DEF* jobName;                          /* User friendly name of the Job.                     */
       pwgINFO_DEF* jobOriginatingUserName;
    pwgNUM_RNG_DEF* docCharsetSupplied;               /* Default charset of the Documents content.          */
    pwgNUM_RNG_DEF* docFormatSupplied;                /* Document format for the Document content.          */
       pwgINFO_DEF* docFormatVersionSuppliled;        /* Doc Format Version                                 */
       pwgINFO_DEF* docNameSupplied;                  /* Supplied Document Name                             */
       pwgINFO_DEF* docUri;                           /* URI reference to the document of this job          */
    pwgNUM_RNG_DEF* jobCollType;                      /* Sheet/document collation for the Job               */
    pwgNUM_RNG_DEF* pageOrderReceived;                /* Page order Document data is supplied               */

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
     pwgSTRUCT_DEF* docFormatDetailsSupplied;         /* Summarizes distinctions contained doc fmts.        */
       pwgINFO_DEF* jobOriginatingUserUri;            /* URI ref to end user                                */
        pwgNUM_DEF* jobPages;                         /* Total number input pages of documents in Job       */
        pwgNUM_DEF* kOctets;                          /* Total size of Job Doc's in 1024 octets.            */
        pwgNUM_DEF* impressions;                      /* Number of impressions for all Document(s).         */
        pwgNUM_DEF* mediaSheets;                      /* Number media sheets produced for this Doc          */
#endif

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
       pwgINFO_DEF* jobMessageFromOperator;           /* Message from operator                              */
       pwgINFO_DEF* jobMessageToOperator;             /* User Message to operator                           */

       pwgINFO_DEF* jobPassword;                      /* Password supplied by the client                    */
    pwgNUM_RNG_DEF* jobPasswordEncryption;            /* Encryption for the supplied Job Password           */

       pwgINFO_DEF* templateCreatorUserName;
       pwgINFO_DEF* templateId;                       /* URI to template Id                                 */
       pwgINFO_DEF* templateInfo;                     /* Info for template                                  */
       pwgINFO_DEF* templateName;                     /* Name for template                                  */
    pwgNUM_RNG_DEF* templateType;                     /* Template Type used to create the Job Ticket        */
    pwgNUM_RNG_DEF* compressionSupplied;              /* compression algorithm for all Job Document's       */
    pwgNUM_RNG_DEF* docDigitalSignatureSupplied;      /* Digital signature type for Doc Content.            */
       pwgINFO_DEF* docMessageSupplied;               /* Message (to operator)                              */
       pwgINFO_DEF* docMetadata;                      /* Document Meta Data                                 */
#endif

    VND_PRT_JOB_DESC_DEF_STRUCT

           pwgVOID* last;
} pwgPrintJobDescDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern pwgPrintJobDescDefLst pwgPrtJobDescDefElem;
extern pwgSTRUCT_DEF         pwgDef_PrintJobDescription;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */


#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PRINT_JOB_DESCRIPTION__N_H__                                                               */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ==================================== pwg.print.job.description.N.h ===================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
