/* ====================================== pwg.print.job.ticket.h ========================================== */
/* ..................................................|..................................................... */
 
/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PRINT_JOB_TICKET_H__
#define __PWG_PRINT_JOB_TICKET_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.print.job.ticket.config.h"

#include "pwg.print.document.processing.N.h"
#include "pwg.print.job.description.N.h"
#include "pwg.print.job.processing.N.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* pwgPrintJobTicket                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §4.1 [page 12-13] Overview                                                                          */
/* -----------------                                                                                        */
/* As shown in Figure 2 the PrintJobTicket datatype contains three groups of elements.  With the exception  */
/* of the JobName element in PrintJobDescription, all PrintJobTicket elements are optional.                 */
/*                                                                                                          */
/*    +~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+      */
/*                                                                                                          */
/*                     + . . . . . . . . . . . . . . . . . . . . . . . . . +                                */
/*                     .  PrintJobTicketType                               .                                */
/*                     .                                                   .                                */
/*                     .                    + - - - - - - - - - - - - + 123.                                */
/*                     .                + - | PrintDocumentProcessing |+   .                                */
/*                     .                !   + - - - - - - - - - - - - +    .                                */
/*                     .                !                                  .                                */
/* +----------------+  .  /---------\   !   + - - - - - - - - - - + 123    .                                */
/* | PrintJobTicket |--.--| -o-o-o- |-- + - | PrintJobDescription |+       .                                */
/* +----------------+  .  \---------/   !   + - - - - - - - - - - +        .                                */
/*                     .                !                                  .                                */
/*                     .                !   + - - - - - - - - - - + 123    .                                */
/*                     .                + - | PrintJobProcessing  |+       .                                */
/*                     .                !   + - - - - - - - - - - +        .                                */
/*                     .                !                                  .                                */
/*                     .                !   / - - - - - - -\ 123           .                                */
/*                     .                + - | any ##other  |               .                                */
/*                     .                    \ - - - - - - -/               .                                */
/*                     .                        0..infinite                .                                */
/*                     .                                                   .                                */
/*                     + . . . . . . . . . . . . . . . . . . . . . . . . . +                                */
/*                                                                                                          */
/*                                     Figure 2 PrintJobTicket                                              */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + - - - - + 123                      ! = Optional    */
/*      ! Optional Element  !   | Required Element |   | Element | ^^^ Support Level        | = Required    */
/*      X - - - - - - - - - Y   X------------------Y   + - - - - +                                          */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*                                                                                                          */
/* The PrintJobTicket datatype contains elements for job and document processing, and for the descriptive   */
/* properties of a PrintJob. PrintJobDescription and PrintJobProcessing elements apply to the entire Job.   */
/* PrintDocumentProcessing Elements apply to all Documents within the Job unless overridden at the Document */
/* level.  In other words the Job's PrintDocumentProcessing element contains the requested values for all   */
/* the contained Documents except when overridden by a PrintDocumentTicket.  The typical PrintJob contains  */
/* only a single Document and does not contain a PrintDocumentTicket.                                       */
/*                                                                                                          */
/* The most common form of a PrintJob contains only a single document.  The PrintJobTicket's                */
/* PrintDocumentProcessing elements are applied to all the Documents in the Job.  PrintDocumentTickets are  */
/* optional in single and multi-document jobs.   The PrintDocumentTicket defines exception processing on a  */
/* per document basis.  The PrintDocumentTicket datatype contains elements for document processing and      */
/* descriptive properties of a Document within a PrintJob. A Document's PrintDocumentProcessing elements    */
/* will override the values specified in the PrintJobTicket's PrintDocumentProcessing element.              */
/*                                                                                                          */
/*                                                                                                          */
/* The PrintJobTicket datatype is used in a number of ways associated with the PrintJob.                    */
/*                                                                                                          */
/*        * It is the datatype of the PrintJobTicket data object used in a job creation protocol to carry   */
/*          the PrintService Client's print intent.  The content of a PrintJobTicket is configured by a     */
/*          User through a PrintService Client.  The PrintJobTicket is then submitted by the PrintService   */
/*          Client to the PrintService along with the Document(s) to print. PrintServices MUST gracefully   */
/*          handle PrintJobTickets that contain unsupported elements and values.                            */
/*                                                                                                          */
/*        * It is the datatype of the PrintJobTicket data object used in a PrintJob Object to indicate the  */
/*          accepted request.  This might differ from the PrintService Client request.  It might have been  */
/*          modified to resolve conflicting or unsupported elements.  (See ### section 4.2 ### below)       */
/*                                                                                                          */
/*        * It may be used in the PrintJob to carry the applied PrintJobTickets elements as a PrintJob is   */
/*          processed by the PrintService. The PrintJobReceipt records the JobTicket elements applied to    */
/*          the PrintJob.  This element is created and populated by the PrintService as the PrintJob is     */
/*          processed.  The PrintJobReceipt MUST include all the PrintJobTicket's elements as they are      */
/*          applied to the PrintJob.  Additionally the PrintJobReceipt MUST include the default elements,   */
/*          and values, when they have been applied to the PrintJob. (i.e., PrintJobReceipt).               */
/*                                                                                                          */
/*        * It is used by the PrintService to indicate the default values for the PrintService.  The        */
/*          DefaultPrintJobTicket is the representation of the defaults supplied by the PrintService when   */
/*          the corresponding element is not included with a PrintJob Creation Request (i.e.,               */
/*          PrintServiceDefaults).                                                                          */
/*                                                                                                          */
/* The PrintJobTicketCapabilities datatype is closely related to the PrintJobTicket datatype. For every     */
/* element in PrintJobTicket there is an associated PrintServiceCapabilities element. (See Appendix F       */
/* and G)  The primary difference is the datatype of the associated capabilities element.  The capabilities */
/* element is used to indicate if a PrintJobTicket element is supported by the PrintService and its         */
/* supported values.    In some cases all that is required is a Boolean to indicate the element is          */
/* supported.  For the other elements the range or list of values supported is provided. (See Appendix A)   */
/*                                                                                                          */
/* The PrintJobTicketCapabilities datatype is used by the PrintService in two ways.                         */
/*                                                                                                          */
/*        * It is used within PrintServiceCapabilities to indicate the full set of supported elements and   */
/*          values (e.g., media even if it is not currently loaded in any input tray)                       */
/*                                                                                                          */
/*        * It is used within PrintServiceCapabilitiesReady to indicate the elements and values that can be */
/*          honored without operator intervention (e.g., media that is currently loaded in an input tray).  */
/*                                                                                                          */
/* Although the model contains a large number of elements, most of them are optional.  This allows a wide   */
/* variety of PrintServices, and PrintService Clients to make use of the model.  The model supports         */
/* PrintService with limited features up to production class PrintServices.   Compliant PrintService        */
/* Clients can interoperate with them all.  ### Section 8.1 ### specifies the REQUIRED and CONDITIONALLY    */
/* REQUIRED subset of elements for the PWG PrintJobTicket.                                                  */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                       */
    /*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)   */
    /*      §4.2 [page 13-14] MustHonor element processing.                                                 */
    /* -----------------                                                                                    */
    /* The PrintService creates a PrintJob when it accepts a PrintJob Creation Request.  The PrintJob       */
    /* contains a copy of the submitted PrintJobTicket, possibly modified.  The User has the ability to     */
    /* specify "best effort" or "MustHonor" for any of the processing elements within a PrintJobTicket.     */
    /* The "MustHonor" processing model also applies to PrintDocumentTickets.                               */
    /*                                                                                                      */
    /* When a processing element is marked "MustHonor" it means that the element and its value MUST be      */
    /* supported by the PrintService and MUST be bound to the PrintJob or the PrintService MUST NOT accept  */
    /* the PrintJob.  All other processing elements are "best effort".  The PrintService MAY omit the       */
    /* processing element.  The PrintService MAY change the processing element's value.                     */
    /*                                                                                                      */
    /* The newly created PrintJob contains the accepted PrintJobTicket. The PrintService's                  */
    /* PrintServiceDefault elements and values not specified by the User MUST NOT be included in the        */
    /* PrintJob's PrintJobTicket.  The PrintService MUST inform the PrintService Client whether             */
    /* modi?cations have been made to the submitted PrintJobTicket in the PrintJob Creation response.       */
    /*                                                                                                      */
    /* When the PrintService begins to process a Job, and a processing feature specified in the             */
    /* PrintJobTicket is unavailable and the PrintJobTicket element is not marked "MustHonor", PrintService */
    /* MAY omit the processing element or change the processing element's value. If the PrintJobTicket      */
    /* element is marked "MustHonor", it is an implementation decision whether to abort the Job or to place */
    /* the Job in the Stopped state until the associated processing feature is available or the             */
    /* PrintJobTicket is modified by the Job owner or administrator.                                        */
    /*                                                                                                      */
    /* ==================================================================================================== */
    /* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                       */
    /*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)   */
    /*      §8.1 [page 34-36] 8.1 PrintJobTicket Conformance Requirements                                   */
    /* -----------------                                                                                    */
    /* For the purposes of usability and interoperability a subset of the PrintJobTicket elements are       */
    /* specified as REQUIRED or CONDITIONALLY REQUIRED.                                                     */
    /*                                                                                                      */
    /*                    REQUIRED: elements MUST be supported in the PrintJobTickets by all conforming     */
    /*                              PrintServices.                                                          */
    /*      CONDITIONALLY REQUIRED: means that if the PrintService supports the associated feature          */
    /*                              semantics of the listed PrintJobTicket elements, it MUST support the    */
    /*                              PrintJobTicket element even if a vendor extension covers the same       */
    /*                              semantic feature.  For example if your PrintService permits the         */
    /*                              selections of specific pages within a document to be printed, then your */
    /*                              printer MUST support the PageRanges PrintJobTicket element.             */
    /*                                                                                                      */
    /* If your PrintService has a vendor extension that controls this feature, then your PrintService MAY   */
    /* support that vendor extension element as well.  When both the PrintJobTicket and the vendor          */
    /* extension elements for the same feature are specified and one or more of them have "MustHonor"       */
    /* specified, then the usual "MustHonor" processing rules apply (See §4.2).  If both the PrintJobTicket */
    /* and the vendor extension elements for the same feature are specified and "MustHonor" is not          */
    /* involved, the PrintJobTicket element MUST take precedence.                                           */
    /*                                                                                                      */
    /* Minimal PrintService Clients can be created that do not submit PrintJobTicket elements.  The         */
    /* resulting Job will use the PrintService's defaults.  PrintService Clients may use any of the         */
    /* REQUIRED PrintJobTicket elements with any conforming PrintService.  PrintService Clients can use any */
    /* of the CONDITIONALLY REQUIRED PrintJobTicket elements with any conforming PrintService that supports */
    /* the element.  Complex PrintService Clients can be created that use any of the PrintJobTicket         */
    /* elements defined in this specification or defined by vendor extensions.                              */
    /*                                                                                                      */
    /* Table 1 and Table 2 below specify the set of REQUIRED and CONDITIONALLY REQUIRED PrintJobTicket      */
    /* elements for a conforming PrintService.  See Appendix A for a description of the elements.  The Open */
    /* Printing Job Ticket API specification [JTAPI] was considered when determining the set of REQUIRED    */
    /* Job Ticket elements.                                                                                 */
    /*                                                                                                      */
    /*                          Table 1 Descriptive PrintJobTicket Elements                                 */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    |    | Element Name                   | Group                     | Conformance             |     */
    /*    +====+================================+===========================+=========================+     */
    /*    | 1. | Compression/                   | PrintJobDescription       | CONDITIONALLY REQUIRED  |     */
    /*    |    | CompressionSupplied            |                           |                         |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 2. | DocumentFormat/                | PrintJobDescription       | REQUIRED                |     */
    /*    |    | DocumentFormatSupplied         |                           |                         |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 3. | DocumentUri (note 1)           | PrintDocumentDescription  | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 4. | JobName                        | PrintJobDescription       | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 5. | JobOriginatingUserName         | PrintJobDescription       | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 6. | JobOriginatingUserUri          | PrintJobDescription       | CONDITIONALLY REQUIRED  |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*         Note 1: Element indicates support for printing by reference                                  */
    /*                                                                                                      */
    /*                          Table 2 Processing PrintJobTicket Elements                                  */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    |    | Element Name                   | Group                     | Conformance             |     */
    /*    +====+================================+===========================+=========================+     */
    /*    | 1. | JobCopies or Copies            | PrintJobProcessing or     | REQUIRED                |     */
    /*    |    |                                | PrintDocumentProcessing   |                         |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 2. | JobFinishings or Finishings {  | PrintJobProcessing or     | CONDITIONALLY REQUIRED  |     */
    /*    |    |   JogOffset,                   | PrintDocumentProcessing   |                         |     */
    /*    |    |   None,                        |                           |                         |     */
    /*    |    |   Punch,                       |                           |                         |     */
    /*    |    |   Staple,                      |                           |                         |     */
    /*    |    |   StapleBottomLeft,            |                           |                         |     */
    /*    |    |   StapleBottomRight,           |                           |                         |     */
    /*    |    |   StapleDualBottom,            |                           |                         |     */
    /*    |    |   StapleDualLeft,              |                           |                         |     */
    /*    |    |   StapleDualRight,             |                           |                         |     */
    /*    |    |   StapleDualTop,               |                           |                         |     */
    /*    |    |   StapleTopLeft,               |                           |                         |     */
    /*    |    |   StapleTopRight }             |                           |                         |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 3. | Media                          | PrintDocumentProcessing   | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 4. | MediaType                      | PrintDocumentProcessing   | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 5. | MustHonor or                   | PrintJobTicket or         | REQUIRED                |     */
    /*    |    | JobRequiredElements            | PrintJobProcessing        |                         |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 6. | OrientationRequested           | PrintDocumentProcessing   | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 7. | PageRanges                     | PrintDocumentProcessing   | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 8. | PrintColorMode                 | PrintDocumentProcessing   | CONDITIONALLY REQUIRED  |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 9. | Quality                        | PrintDocumentProcessing   | REQUIRED                |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*    | 10.| Sides                          | PrintDocumentProcessing   | CONDITIONALLY REQUIRED  |     */
    /*    +----+--------------------------------+---------------------------+-------------------------+     */
    /*                                                                                                      */
    /* ==================================================================================================== */
typedef struct {
    pwgPrintDocumentProcessing  docProc;              /* Document Processing Object for the Print Job Ticket*/
    pwgPrintJobDescription      jobDesc;              /* Job Description     Object for the Print Job Ticket*/
    pwgPrintJobProcessing       jobProc;              /* Job Processing      Object for the Print Job Ticket*/

    VND_PRINT_JOB_TICKET_STRUCT

} pwgPrintJobTicket, pwgPJT;

typedef struct {
    pwgSTRUCT_DEF*                docProcDef;         /* Document Processing Object for the Print Job Ticket*/
    pwgSTRUCT_DEF*                jobDescDef;         /* Job Description     Object for the Print Job Ticket*/
    pwgSTRUCT_DEF*                jobProcDef;         /* Job Processing      Object for the Print Job Ticket*/

    VND_PRINT_JOB_TICKET_DEF_STRUCT

    pwgVOID*                      last;
} pwgPJT_DefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern pwgPJT_DefLst pwgPjtDefElem;
extern pwgSTRUCT_DEF pwgDef_PrintJobTicket;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */


#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PRINT_JOB_TICKET_H__                                                                       */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ====================================== pwg.print.job.ticket.h ========================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
